#include "jserver.h"
#include "dlfcn.h"

/* loads the shared object and calls the init function */
void *dso_load(char *so, char *init, void *arg)
{
    void (*init_h)(void *arg);
    void *so_h;
    char *dlerr;
    char *defso;

    debug("dso_init");

    if(so == NULL)
        return NULL;

    so_h = dlopen(so,RTLD_LAZY);
    dlerr = dlerror();
    if(dlerr != NULL)
    {
        error("jserver_dso_load",so);
        error("jserver_dso_load_err",dlerr);
        defso = malloc(strlen(MODLIBDIR) + strlen(so) + 2);
        *defso = '\0';
        strcat(defso,MODLIBDIR);
        strcat(defso,"/");
        strcat(defso,so);
        so_h = dlopen(defso,RTLD_LAZY);

        dlerr = dlerror();
        if(dlerr != NULL)
        {
            error("jserver_dso_load",defso);
            error("jserver_dso_load_err",dlerr);
            free(defso);
            return NULL;
        }
        free(defso);
    }

    if(init == NULL)
        return so_h;

    init_h = dlsym(so_h,init);
    dlerr = dlerror();
    if(dlerr != NULL)
    {
        error("jserver_dso_init",init);
        error("jserver_dso_init_err",dlerr);
    }
    (init_h)(arg);

    return so_h;
}



