#include "jserver.h"

/* thread that handles data for unknown resources, 
 * might be for offline users, etc */

void *unknown_main(void *arg)
{
    pth_event_t ev;
    pth_msgport_t mp;
    jpq q;
    
    debug("THREAD:UNKNOWN starting");

    mp = pth_msgport_create("unknown");
    ev = pth_event(PTH_EVENT_MSG,mp);

    while(1)
    {
        pth_wait(ev);
        while((q = (jpq)pth_msgport_get(mp)) != NULL)
        {
            debug("THREAD:UNKNOWN received a message: %s",xmlnode2str(q->p->x));
            /* use module API to handle these or bounce them to the p->from */
            xmlnode_free(q->p->x);
        }
    }
    
    pth_event_free(ev,PTH_FREE_ALL);
    pth_msgport_destroy(mp);
}

