#include "jserver.h"

int presence_priority(xmlnode x)
{
    char *str;
    int ret = 0;

    if(x == NULL)
        return ret;

    x = xmlnode_get_tag(x,"priority");
    if(x == NULL)
        return ret;

    str = xmlnode_get_data(xmlnode_get_firstchild(x));
    if(str == NULL)
        return ret;

    return atoi(str);
}

struct pcheck_struct
{
    char *id;
    struct pcheck_struct *next;
};

/* simple little bit flipper utility tracking id's availability server-wide */
int presence_check(int cmd, char *id)
{
    static struct pcheck_struct *list = NULL;
    struct pcheck_struct *next, *prev;

    if(id == NULL)
        return 0;

    prev = next = list;
    while(next != NULL)
    {
        if(strcmp(next->id,id) == 0)
            break;
        prev = next;
        next = next->next;
    }

    if(cmd == CMD_SET)
    {
        if(next == NULL)
        {
            next = malloc(sizeof(struct pcheck_struct));
            next->id = strdup(id);
            next->next = list;
            list = next;
        }else{
            free(next->id);
            next->id = strdup(id);
        }
    }

    if(cmd == CMD_DEL && next != NULL)
    {
        if(list == next)
            list = list->next;
        else
            prev->next = next->next;
        free(next->id);
        free(next);
        next = NULL;
    }

    if(next == NULL)
        return 0;
    else
        return 1;
}

udata users = NULL;

/* you can't pass this NULL! */
udata user_data(char *user)
{
    udata next;

    next = users;
    while(next != NULL)
    {
        if(j_strcmp(next->user, user) == 0)
            return next;
        next = next->next;
    }

    next = malloc(sizeof(struct user_struct));
    memset(next, '\0', sizeof(struct user_struct));
    next->user = strdup(user);
    next->next = users;
    users = next;
    return next;
}
